//{$DEFINE TEECHARTSTANDARD}
//
// tchart left,top will be TIWchart size/position
// width,height will be chart.width & chart.height
// if go by tiwchart width/geight and try re-size , won't allow.....
//

unit IWTChart;


interface

uses
  Classes,controls,
  Chart, Series,
  IWExtCtrls, IWHTMLTag, IWRenderContext,TeCanvas,TeEngine;

type
  TIWTChart=class(TIWDynamicImage)
  private
  public
    Chart: TCustomChart;
    Series1: TBarSeries;
    Constructor Create(AOwner: TComponent;AParent:tWincontrol);
    Destructor Destroy; override;

    Function RenderHTML(AContext: TIWCompConText):TIWHTMLTag; override;
  end;

implementation

uses
  SysUtils, Graphics, TeeProcs;

Constructor TIWTChart.Create(AOwner:TComponent;AParent:tWincontrol);
begin
  inherited Create(aOwner);
  Parent:=AParent;
  CreatePicture;
  Chart := TChart.Create(Self);
  Series1 := TBarSeries.Create(Chart);
  Chart.AddSeries(Series1);
  with Chart do
  begin
    Border.Color:= clNavy;
    Border.Width := 6;
    Border.Visible := True;
    Gradient.EndColor := clGray;
    Gradient.Visible := True;
    Legend.Gradient.Direction := gdTopBottom;
    Legend.Gradient.EndColor := clYellow;
    Legend.Gradient.StartColor := clWhite;
    Legend.Gradient.Visible := True;
    Legend.Visible := False;
    AutoSize := True;
    ColorPaletteIndex := 13;
    Name := 'chart1iw';
    Left := 10;
    Top := 10;
    Width := 200;
    Height := 200;
    Title.Text.Clear;
    Title.Text.Add('TChart');
//    BevelOuter := bvNone;
    Visible := true;
  end;
  with Series1 do
  begin
    Marks.Arrow.Visible := True;
    Marks.Callout.Brush.Color := clBlack;
    Marks.Callout.Arrow.Visible := True;
    Marks.Visible := True;
    Gradient.Direction := gdTopBottom;
    XValues.Name := 'X';
    XValues.Order := loAscending;
    YValues.Name := 'Bar';
    YValues.Order := loNone;
    Name := 'series1iw';
  end;

end;

Destructor TIWTChart.Destroy;
begin
  inherited;
end;


Function TIWTChart.RenderHTML(AContext: TIWCompConText):TIWHTMLTag;
var tmp : TBitmap;
begin
  if Assigned(Chart) then begin
    FPicture.Bitmap.Width:=Chart.Width;
    FPicture.Bitmap.Height:=Chart.Height;

    {$IFDEF TEECHARTSTANDARD}

    // For compatibility with TeeChart Standard v4.
    // Use a somewhat slower method to obtain a picture from FChart chart:

    tmp:=Chart.TeeCreateBitmap(Color,Rect(0,0,Width,Height));
    try
      FPicture.Assign(tmp);
    finally
      tmp.Free;
    end;

    {$ELSE}

    // With TeeChart Pro do a more aggressive (and fast) way to get FChart picture:
    FPicture.Assign(Chart);

    {$ENDIF}

  end;

  result:=inherited RenderHTML(AContext);
end;


end.

